using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.Primitives;

namespace RadRibbonBarQuickAccess
{
    public partial class Form1 : ShapedForm
    {
        #region Boolean fields

        bool isFirstNormalButtonActive = false;
        bool isSecondNormalButtonActive = false;

        #endregion

        #region Form constructor

        public Form1()
        {
            InitializeComponent();
        }

        #endregion

        #region Switch between approaches

        private void radToggleButton1_ToggleStateChanged(object sender, StateChangedEventArgs args)
        {
            if (radToggleButton1.ToggleState == Telerik.WinControls.Enumerations.ToggleState.Off)
            {
                rlblApproach.Text = "Setting the BackColors of normal buttons";
                SetNormalButtons();
            }
            else
            {
                rlblApproach.Text = "Inserting RadToggleButtons in the QuickAccessToolBar";
                SetToggleButtons();
            }
        }

        #endregion

        #region Set the colors of the normal buttons using boolean flags

        void normalButton_Click(object sender, EventArgs e)
        {
            if ((((RadButtonElement)sender).Text) == "X")
            {
                isFirstNormalButtonActive = !isFirstNormalButtonActive;
                if (isFirstNormalButtonActive == true)
                {
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor2 = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor3 = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor4 = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).NumberOfColors = 4;
                }
                else
                {
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor2 = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor3 = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor4 = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).NumberOfColors = 4;
                }
            }
            else if ((((RadButtonElement)sender).Text) == "Y")
            {
                isSecondNormalButtonActive = !isSecondNormalButtonActive;
                if (isSecondNormalButtonActive == true)
                {
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor2 = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor3 = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor4 = Color.Yellow;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).NumberOfColors = 4;
                }
                else
                {
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor2 = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor3 = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).BackColor4 = Color.Transparent;
                    ((FillPrimitive)((RadButtonElement)sender).Children[0]).NumberOfColors = 4;
                }
            }
        }

        #endregion

        #region Set toggle buttons

        private void SetToggleButtons()
        {
            this.radRibbonBar1.QuickAccessToolBarItems.Clear();

            RadToggleButtonElement toggleButton1 = new RadToggleButtonElement();
            toggleButton1.Text = "X";
            this.radRibbonBar1.QuickAccessToolBarItems.Add(toggleButton1);

            RadToggleButtonElement toggleButton2 = new RadToggleButtonElement();
            toggleButton2.Text = "Y";
            this.radRibbonBar1.QuickAccessToolBarItems.Add(toggleButton2);
        }

        #endregion

        #region Set normal buttons

        private void SetNormalButtons()
        {
            this.radRibbonBar1.QuickAccessToolBarItems.Clear();

            isFirstNormalButtonActive = false;
            isSecondNormalButtonActive = false;

            RadButtonElement normalButton1 = new RadButtonElement();
            normalButton1.Text = "X";
            this.radRibbonBar1.QuickAccessToolBarItems.Add(normalButton1);

            RadButtonElement normalButton2 = new RadButtonElement();
            normalButton2.Text = "Y";
            this.radRibbonBar1.QuickAccessToolBarItems.Add(normalButton2);

            normalButton1.Click += new EventHandler(normalButton_Click);
            normalButton2.Click += new EventHandler(normalButton_Click);
        }

        #endregion
    }
}